
#ifndef BLAHTECH_SUP_DEM_CUSTOM_ARGS_MQH
#define BLAHTECH_SUP_DEM_CUSTOM_ARGS_MQH

#property description "Blahtech Supply Demand Custom Args"
#property link        "http://www.blahtech.co.uk"
#property strict

#include "BlahtechUtils.mqh"

const string TIMEFRAME_MAP1 = "M1=M5,M5=M30,M15=H1,M30=H4,H1=H4,H4=D1,D1=W1,W1=MN1,MN1=Q1";
const string TIMEFRAME_MAP2 = "M1=M5,M5=M30,M15=H1,M30=H4,H1=H4,H4=D1,D1=W1,W1=MN1,MN1=Q1";
const string TIMEFRAME_MAP3 = "M1=M30,M5=H1,M15=H4,M30=D1,H1=D1,H4=W1,D1=MN1,W1=Q1,MN1=Y1";

class SupDemCustomArgs
{
public:
   string            StrSymbol;
   ENUM_TIMEFRAMES   Timeframe;
   string            IndicatorPath;
   SdEaModeEnum      ExpertMode;
   int               MinBarsLevel;
   int               MaxBars;
   int               ForceRecalcBars; 
   string            ParameterValues;
   MAPPED_TIMEFRAMES Timeframe1;
   MAPPED_TIMEFRAMES Timeframe2;
   MAPPED_TIMEFRAMES Timeframe3;

public:
   SupDemCustomArgs();
};

SupDemCustomArgs::SupDemCustomArgs() :
   StrSymbol(_Symbol),
   Timeframe((ENUM_TIMEFRAMES)_Period),
   IndicatorPath(""),
   ExpertMode(SD_EA_EXPERT),
   MinBarsLevel(3),
   MaxBars(20000),
   ForceRecalcBars(10000),
   ParameterValues(""),
   Timeframe1(MAP_PERIOD_CURRENT),
   Timeframe2(MAP_PERIOD_MAPPED),
   Timeframe3(MAP_PERIOD_MAPPED)
{
}

#endif
