
#property description "Blahtech Supply Demand Expert Advisor - Basic"
#property version     "3.2"
#property strict

#include "BlahtechSupDemControlBasic.mqh"

#ifdef __MQL4__
input string             IndicatorPath = "Market\\Blahtech Supply Demand";          // Indicator Path
#else
input string             IndicatorPath = "Market\\Blahtech Supply Demand MT5.ex5";  // Indicator Path
#endif
input SdEaModeEnum       ExpertMode = SD_EA_EXPERT_NO_DRAW;                         // Expert Mode
input int                MinBarsLevel = 3;                                          // Min Bars For Level
input int                MaxBars = 20000;                                           // Max Bars
input int                ForceRecalcBars = 10000;                                   // Force Recalc Bars
input string             ParameterValues = "";                                      // Parameter Key Value Pairs
//input string             ParameterValues = "ZoneStyle1=2;InfoLevel=1 S;";         // Parameter Key Value Pairs
input MAPPED_TIMEFRAMES  Timeframe1 = MAP_PERIOD_CURRENT;                           // Timeframe 1
input MAPPED_TIMEFRAMES  Timeframe2 = MAP_PERIOD_MAPPED;                            // Timeframe 2
input MAPPED_TIMEFRAMES  Timeframe3 = MAP_PERIOD_MAPPED;                            // Timeframe 3
input SdEaRetouchMode    UpdateRetouches = SD_EA_RETOUCH_FIRST;                     // Update Retouches Mode
input SdEaValidateEnum   ValidateIncremental = SD_EA_VAL_NONE;                      // Validate Incremental
input LogLevelEnum       LogLevel = LogError;                                       // Log Level   


SupDemCustomArgs*    ExtCustomArgs1;
SupDemControlBasic*  ExtControlBasic1;


int OnInit()
{
   if (LogLevel >= LogInfo) { Print("OnInit - Start"); }
   
   ExtCustomArgs1 = new SupDemCustomArgs();
   ExtControlBasic1 = new SupDemControlBasic();
   
   ExtCustomArgs1.IndicatorPath = IndicatorPath;
   ExtCustomArgs1.ExpertMode = ExpertMode;
   ExtCustomArgs1.MinBarsLevel = MinBarsLevel;
   ExtCustomArgs1.MaxBars = MaxBars;
   ExtCustomArgs1.ForceRecalcBars = ForceRecalcBars;
   ExtCustomArgs1.Timeframe1 = Timeframe1;
   ExtCustomArgs1.Timeframe2 = Timeframe2;
   ExtCustomArgs1.Timeframe3 = Timeframe3;
   
   // ###################################################
   // ## Uncomment and/or modify to add parameter values
   // ###################################################
   ExtCustomArgs1.ParameterValues = "values:"
   "Hud=0;"
   //"SummaryMode=0;"
   //"TimeframeVisible2=1;"
   //"ZoneStyle1=2;"
   //"Timeframe4=-3;"
   //"QPoints=0;"
   //"InfoLevel=8;"
   + ParameterValues; // Append extra values set in input parameters
   
   int ret = ExtControlBasic1.Init(ExtCustomArgs1, UpdateRetouches, LogLevel, ValidateIncremental);

   if (LogLevel >= LogInfo) { Print("OnInit - ret=", ret); }
   return ret;
}


void OnDeinit(const int reason)
{
   DeleteCheck(ExtControlBasic1);
   DeleteCheck(ExtCustomArgs1);
   ChartRedraw();
}


void OnTick()
{
   datetime        time0 = iTime(NULL, 0, 0);                     // ###################################################################################
   SdEaUpdateEnum  sdChanged1 = ExtControlBasic1.Populate(time0); // ## For optimal performance - Edit Populate method and comment out unused variables
                                                                  // ###################################################################################
   if (sdChanged1 > SD_EA_UPDATE_NONE || ExtControlBasic1.NewBar)
   {
      if (sdChanged1 > SD_EA_UPDATE_NONE)
      {
         if (sdChanged1 == SD_EA_UPDATE_FULL)
         {
            // Add user code for full populate
            
         }
         // Add user code for incremental populate
         
         //double firstSupLevelHigh = ExtControlBasic1.SupPriceHigh;
         //double firstSupLevelLow = ExtControlBasic1.SupPriceLow;
         
      }
      
      if (ExtControlBasic1.NewBar)
      {
         // Add user code for new bar (current timeframe)
         
      }
   }
   // Add user code for each tick
   
}
