
#property description "Blahtech Supply Demand Indi Advanced"
#property description "Calling iCustom from another indicator example"
#property version     "3.2"
#property strict
#property indicator_chart_window

// #########################################################################################################
// ## NOTE: This is an indciator and once compiled must be placed under the MT4/Indciators directory to run
// #########################################################################################################

#include "BlahtechSupDemControlAdvanced.mqh"

#ifdef __MQL4__
input string             IndicatorPath = "Market\\Blahtech Supply Demand";          // Indicator Path
#else
input string             IndicatorPath = "Market\\Blahtech Supply Demand MT5.ex5";  // Indicator Path
#endif
input SdEaModeEnum       ExpertMode = SD_EA_EXPERT_NO_DRAW;                         // Expert Mode
input int                MinBarsLevel = 3;                                          // Min Bars For Level
input int                MaxBars = 20000;                                           // Max Bars
input int                ForceRecalcBars = 10000;                                   // Force Recalc Bars
input string             ParameterValues = "";                                      // Parameter Key Value Pairs
//input string             ParameterValues = "ZoneStyle1=2;InfoLevel=1 S;";           // Parameter Key Value Pairs
input MAPPED_TIMEFRAMES  Timeframe1 = MAP_PERIOD_CURRENT;                           // Timeframe 1
input MAPPED_TIMEFRAMES  Timeframe2 = MAP_PERIOD_MAPPED;                            // Timeframe 2
input MAPPED_TIMEFRAMES  Timeframe3 = MAP_PERIOD_MAPPED;                            // Timeframe 3
input SdEaRetouchMode    UpdateRetouches = SD_EA_RETOUCH_FIRST;                     // Update Retouches Mode
input SdEaValidateEnum   ValidateIncremental = SD_EA_VAL_NONE;                      // Validate Incremental
input bool               ForceFullUpdate = false;                                   // Force Full Update Every Change
input LogLevelEnum       LogLevel = LogError;                                       // Log Level

SupDemCustomArgs*       ExtCustomArgs1;
SupDemControlAdvanced*  ExtControlAdvanced1;


int OnInit()
{
   if (LogLevel >= LogInfo) { Print("OnInit - Start"); }
   
   ExtCustomArgs1 = new SupDemCustomArgs();
   ExtControlAdvanced1 = new SupDemControlAdvanced();
   
   ExtCustomArgs1.IndicatorPath = IndicatorPath;
   ExtCustomArgs1.ExpertMode = ExpertMode;
   ExtCustomArgs1.MinBarsLevel = MinBarsLevel;
   ExtCustomArgs1.MaxBars = MaxBars;
   ExtCustomArgs1.ForceRecalcBars = ForceRecalcBars;
   ExtCustomArgs1.Timeframe1 = Timeframe1;
   ExtCustomArgs1.Timeframe2 = Timeframe2;
   ExtCustomArgs1.Timeframe3 = Timeframe3;
   
   // ###################################################
   // ## Uncomment and/or modify to add parameter values
   // ###################################################
   ExtCustomArgs1.ParameterValues = "values:"
   "Hud=0;"
   //"SummaryMode=0;"
   //"TimeframeVisible2=1;"
   //"ZoneStyle1=2;"
   //"Timeframe4=-3;"
   //"QPoints=0;"
   //"InfoLevel=8;"
   + ParameterValues; // Append extra values set in input parameter
   
   int ret1 = ExtControlAdvanced1.Init(ExtCustomArgs1, UpdateRetouches, LogLevel, ValidateIncremental, ForceFullUpdate);
   
   if (LogLevel >= LogInfo) { Print("OnInit - ret1=", ret1); }
   return ret1;
}


void OnDeinit(const int reason)
{
   DeleteCheck(ExtControlAdvanced1);
   DeleteCheck(ExtCustomArgs1);
   ChartRedraw();
}


int OnCalculate(
   const int rates_total,
   const int prev_calculated,
   const datetime &time[],
   const double &open[],
   const double &high[],
   const double &low[],
   const double &close[],
   const long &tick_volume[],
   const long &volume[],
   const int &spread[])
{
   #ifdef __MQL4__
   datetime        time0 = time[0];
   #else
   datetime        time0 = time[rates_total-1];
   #endif                                                            // ###################################################################################
   SdEaUpdateEnum  sdChanged1 = ExtControlAdvanced1.Populate(time0); // ## For optimal performance - Edit Populate method and comment out unused variables
                                                                     // ###################################################################################
                                                                      
   if (sdChanged1 > SD_EA_UPDATE_NONE || ExtControlAdvanced1.NewBar)
   {
      if (sdChanged1 > SD_EA_UPDATE_NONE)
      {
         if (sdChanged1 == SD_EA_UPDATE_FULL)
         {
            // Add user code for full populate
            
         }
         // Add user code for incremental populate
         
         //if (ArraySize(ExtControlAdvanced1.SupLevels1) > 1)
         //{
         //   SupDemLevel* secondSupLevel = ExtControlAdvanced1.SupLevels1[1];
         //   double       secondSupLevelHigh = secondSupLevel.PriceHigh;
         //}
      }
     
      if (ExtControlAdvanced1.NewBar)
      {
         // Add user code for new bar (current timeframe)
         
      }
   }
   // Add user code for each tick
   
   return rates_total;
}
